Loading...
Searching...
No Matches
BALL::QSAR::KNNModel Class Reference

`#include <BALL/QSAR/knnModel.h>`

Inheritance diagram for BALL::QSAR::KNNModel:

## Constructors and Destructors

| KNNModel (const QSARData &q, int k=3)
void | calculateWeights (Eigen::MatrixXd &dist, Eigen::VectorXd &w)
void | setParameters (vector< double > &v)
vector< double > | getParameters () const
bool | optimizeParameters (int k, int no_steps)

## Additional Inherited Members

Public Member Functions inherited from BALL::QSAR::ALLModel
| ALLModel (const QSARData &q, double kw=4)
| ~ALLModel ()
void | setKw (double kw)
virtual Eigen::VectorXd | predict (const vector< double > &substance, bool transform=1)
void | train ()
double | getKw ()
void | saveToFile (string filename)
void | readFromFile (string filename)
| NonLinearModel (const QSARData &q)
| ~NonLinearModel ()
Public Member Functions inherited from BALL::QSAR::RegressionModel
| RegressionModel (const QSARData &q)
| ~RegressionModel ()
virtual EIGEN_MAKE_ALIGNED_OPERATOR_NEW void | operator= (const RegressionModel &m)
const Eigen::MatrixXd * | getTrainingResult () const
void | show ()
Public Member Functions inherited from BALL::QSAR::Model
| Model (const QSARData &q)
virtual | ~Model ()
virtual void | operator= (const Model &m)
void | copyData (const Model &m)
void | copyDescriptorIDs (const Model &m)
void | readTrainingData ()
void | deleteDescriptorIDs ()
bool | optimizeParameters (int k)
virtual double | calculateStdErr ()
std::multiset< unsigned int > * | getDescriptorIDs ()
void | setDataSource (const QSARData *q)
const Eigen::MatrixXd * | getDescriptorMatrix ()
const vector< string > * | getSubstanceNames ()
const vector< string > * | getDescriptorNames ()
const Eigen::MatrixXd | getDescriptorTransformations ()
const Eigen::MatrixXd | getYTransformations ()
const Eigen::MatrixXd * | getY ()
void | setDescriptorIDs (const std::multiset< unsigned int > &sl)
const string * | getType ()
void | getUnnormalizedFeatureValue (int compound, int feature, double &return_value)
void | getUnnormalizedResponseValue (int compound, int response, double &return_value)
RegressionValidation * | validation
const QSARData * | data
Validation * | model_val
void | calculateXX (Eigen::VectorXd &w, Eigen::MatrixXd &res)
void | calculateXY (Eigen::VectorXd &w, Eigen::MatrixXd &res)
void | calculateEuclDistanceMatrix (Eigen::MatrixXd &m1, Eigen::MatrixXd &m2, Eigen::MatrixXd &output)
virtual void | calculateOffsets ()
void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation, int no_coefficients)
void | saveDescriptorInformationToFile (std::ofstream &out)
Protected Member Functions inherited from BALL::QSAR::Model
void | readMatrix (Eigen::MatrixXd &mat, std::ifstream &in, unsigned int lines, unsigned int col)
void | readVector (Eigen::RowVectorXd &vec, std::ifstream &in, unsigned int no_cells, bool column_vector)
void | readModelParametersFromFile (std::ifstream &in)
void | saveModelParametersToFile (std::ofstream &out)
virtual void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation)
void | readResponseTransformationFromFile (std::ifstream &in, int no_y)
void | saveResponseTransformationToFile (std::ofstream &out)
Eigen::VectorXd | getSubstanceVector (const vector< double > &substance, bool transform)
Eigen::VectorXd | getSubstanceVector (const Eigen::VectorXd &substance, bool transform)
void | backTransformPrediction (Eigen::VectorXd &pred)
void | addLambda (Eigen::MatrixXd &matrix, double &lambda)
void | readDescriptorInformation ()
Protected Attributes inherited from BALL::QSAR::ALLModel
double | kw_
double | lambda_
Protected Attributes inherited from BALL::QSAR::RegressionModel
Eigen::MatrixXd | training_result_
Eigen::RowVectorXd | offsets_
int | default_no_opt_steps_
Eigen::MatrixXd | descriptor_matrix_
vector< string > | substance_names_
vector< string > | descriptor_names_
Eigen::MatrixXd | descriptor_transformations_
Eigen::MatrixXd | y_transformations_
Eigen::MatrixXd | Y_
String | type_
std::multiset< unsigned int > | descriptor_IDs_

## Detailed Description

class for automated lazy learning (ALL-QSAR)

Definition at line 19 of file knnModel.h.

## Constructor & Destructor Documentation

## KNNModel()

BALL::QSAR::KNNModel::KNNModel | ( | const QSARData & | q,
|  | int | k = 3 )

## Member Function Documentation

## calculateWeights()

void BALL::QSAR::KNNModel::calculateWeights | ( | Eigen::MatrixXd & | dist,
|  | Eigen::VectorXd & | w )

virtual

Reimplemented from BALL::QSAR::ALLModel.

## getParameters()

vector< double > BALL::QSAR::KNNModel::getParameters | ( |  | ) | const

virtual

Reimplemented from BALL::QSAR::ALLModel.

## optimizeParameters()

bool BALL::QSAR::KNNModel::optimizeParameters | ( | int | d,
|  | int | no_steps )

virtual

Tries to find the optimal kernel width for the current data. Therefore some training data must have been read by the connected QSARData object before running this method.

Reimplemented from BALL::QSAR::ALLModel.

## setParameters()

void BALL::QSAR::KNNModel::setParameters | ( | vector< double > & |  | ) |

virtual

sets the model parameters according to the given values.

Reimplemented from BALL::QSAR::ALLModel.